const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const report_templates = sequelize.define(
    'report_templates',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

format: {
        type: DataTypes.ENUM,
      
      

        values: [

"pdf",


"xlsx",


"docx",


"html"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  report_templates.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



















    db.report_templates.hasMany(db.reports, {
      as: 'reports_template',
      foreignKey: {
          name: 'templateId',
      },
      constraints: false,
    });




//end loop



    db.report_templates.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.report_templates.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.report_templates.hasMany(db.file, {
      as: 'template_files',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.report_templates.getTableName(),
        belongsToColumn: 'template_files',
      },
    });


    db.report_templates.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.report_templates.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return report_templates;
};


